Attribute VB_Name = "Timevb"
'//--------------------------------------------------------------------------
'// Copyright (C) 1992,1993,1994,1995,1996,1997,1998 Dallas Semiconductor Corporation.
'// All rights Reserved. Printed in U.S.A.
'// This software is protected by copyright laws of
'// the United States and of foreign countries.
'// This material may also be protected by patent laws of the United States
'// and of foreign countries.
'// This software is furnished under a license agreement and/or a
'// nondisclosure agreement and may only be used or copied in accordance
'// with the terms of those agreements.
'// The mere transfer of this software does not imply any licenses
'// of trade secrets, proprietary technology, copyrights, patents,
'// trademarks, maskwork rights, or any other form of intellectual
'// property whatsoever. Dallas Semiconductor retains all ownership rights.
'//--------------------------------------------------------------------------
'

Option Explicit

'// Global Variable Declaration

Global state_buffer(15360) As Byte
Global PortNum As Integer
Global PortType As Integer
Global Timebuf(4) As Byte
Public Const Address As Integer = &H2
Public Const Read_Memory As Integer = &HF0
Public Const family As Integer = &H4 '// family code for DS1994

'// declare the functions to read the registry
Declare Function RegOpenKeyExA Lib "Advapi32.DLL" (ByVal hKey As Long, ByVal lpszSubKey As String, ByVal dwReserved As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueExA Lib "Advapi32.DLL" (ByVal hKey As Long, ByVal lpszValueName As String, ByVal lpdwReserved As Any, lpdwType As Long, lpbData As Byte, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "Advapi32.DLL" (ByVal hKey As Long) As Long
Public Const KEY_READ As Long = &H120019
Public Const HKEY_LOCAL_MACHINE As Long = &H80000002
Public Const ERROR_SUCCESS As Long = &H0
Public Const REG_SZ As Long = &H1

Sub ConvertTime()
    Dim dm(14) As Integer
    dm(0) = 0
    dm(1) = 0
    dm(2) = 31
    dm(3) = 59
    dm(4) = 90
    dm(5) = 120
    dm(6) = 151
    dm(7) = 181
    dm(8) = 212
    dm(9) = 243
    dm(10) = 273
    dm(11) = 304
    dm(12) = 334
    dm(13) = 365
    Dim frsec As Integer, sec As Integer, min As Integer
    Dim hour As Integer, century As Integer
    Dim day As Integer, month As Integer, year As Integer
    Dim x As Long, y As Long
    Dim temp As Integer, i As Integer, j As Integer
    Dim timestr As String
    
'// Get value of number of seconds
    For i = 3 To 0 Step -1
        x = Fix(x * 256) '// Shift left by 8
        x = x Or Timebuf(i + 1)
        x = x
    Next i
    
'// Get the hundredths of a second
    frsec = 100 * Timebuf(0) / 256
    
'// Check to make sure date is not over 2020
    If (x > &H5FDD4280) Then
        x = 0
    End If
    
'// Separate time and date
    y = Fix(x / 60)
    sec = x - 60 * y
    x = Fix(y / 60)
    min = y - 60 * x
    y = Fix(x / 24)
    hour = x - 24 * y
    x = 4 * (y + 731)
    year = Fix(x / 1461)
    
    i = Int(x / 4 - 1461 / 4 * year)
    month = 13
    Do
        month = month - 1
        If ((month > 2) And ((year And &H3) = 0)) Then
            temp = 1
        Else: temp = 0
        End If
        j = dm(month) + temp
    Loop While (i < j)
    
    day = i - j + 1
    If (day = 0) Then
        day = 1
    End If
    
    If (year < 32) Then
        year = year + 68
    Else: year = year - 32
    End If
    
    If (year > 69) Then
        century = 19
    Else: century = 20
    End If
    
'// Display the date and time from DS1994's time register
    timestr = "DATE AND TIME: " + Format(month, "00") + "/" + Format(day, "00")
    timestr = timestr + "/" + Format(century, "00") + Format(year, "00") + "    "
    timestr = timestr + Format(hour, "00") + ":" + Format(min, "00") + ":"
    timestr = timestr + Format(sec, "00") + "." + Format(frsec, "00")
    Timevb32.Label6.Caption = timestr
End Sub

Sub ReadTime(SHandle As Long)
    Dim i As Integer, x As Integer, cnt As Integer
    Dim flag As Integer
    Dim change As Boolean
    
    change = True
    cnt = 0
'// Loop to read the time register
    While ((change = True) And (cnt < 5))
    '// Access the device
        If TMAccess(SHandle, state_buffer(0)) = 1 Then
        '// Send the read memory command
            flag = TMTouchByte(SHandle, Read_Memory)
        '// Send the address
            flag = TMTouchByte(SHandle, Address)
            flag = TMTouchByte(SHandle, Address)
            change = False
        '// Read in the time register
            For i = 0 To 4
                x = TMTouchByte(SHandle, &HFF)
                If (x <> Timebuf(i)) Then
                    If (i <> 0) Then
                        change = True
                    End If
                    Timebuf(i) = x
                End If
            Next i
        '// Increment counter
            cnt = cnt + 1
        End If
    Wend
'// Check to see if time was read correctly
    If (change = False) Then
        Call ConvertTime
    Else
        MsgBox ("Error reading the time register!")
        End
    End If
End Sub

Sub FindFirstFamily(fam As Integer, SHandle As Long)
    Dim i As Integer, flag As Integer
    Dim romstr As String
    Dim ROM(8) As Integer
    
'// Set up to find first device
    If TMFamilySearchSetup(SHandle, state_buffer(0), fam) = 1 Then
        flag = TMNext(SHandle, state_buffer(0))
        If flag = 1 Then
        '// Read the ROM number
            ROM(0) = 0
            flag = TMRom(SHandle, state_buffer(0), ROM(0))
        '// Check for the correct type
            If ((fam And &H7F) = (ROM(0) And &H7F)) Then
            '// Create a string out of the ROM number
                romstr = ""
                For i = 7 To 0 Step -1
                    If (ROM(i) <= &HF) Then romstr = romstr + "0"
                    romstr = romstr + Hex$(ROM(i))
                Next i
                Timevb32.Label5.Caption = "SERIAL ROM ID:  " + romstr
            '// Read the time
                Call ReadTime(SHandle)
            Else
                MsgBox ("There is no DS1994 device on the port! 3")
                End
            End If
        Else
            MsgBox ("There is no DS1994 device on the port! flag =" + CStr(flag))
            End
        End If
    Else
        MsgBox ("There is no DS1994 device on the port! 1")
        End
    End If
End Sub

'// Routine that is executed first
Sub Main()
    Dim Buf As String * 150
    Dim NBuf As String
    Dim RtSize As Long, RtType As Long, GlobKey As Long
    Dim SHandle As Long, Dummy As Long
    Dim cstring(150) As Byte
    Dim i As Integer, setupdone As Integer
    
'// read the Registry to get the default PortNum and PortType
    PortNum = 1
    PortType = 1
'// read Registry for the PortNum
    If (RegOpenKeyExA(HKEY_LOCAL_MACHINE, "Software\Dallas Semiconductor\iButton TMEX\3.00", 0, KEY_READ, GlobKey) = ERROR_SUCCESS) Then
        RtSize = 150
        If (RegQueryValueExA(GlobKey, "DefaultPortNum", vbNullString, RtType, cstring(0), RtSize) = ERROR_SUCCESS) Then
        '// check to verify that the return type is string
            If (RtType = REG_SZ) Then
                NBuf = ""
                i = 1
                While (Asc(Mid(cstring, i, 1)) <> 0)
                    NBuf = NBuf + Mid(cstring, i, 1)
                    i = i + 1
                Wend
                PortNum = Val(NBuf)
            End If
        End If
    '// release the key
        Dummy = RegCloseKey(GlobKey)
    End If
'// read Registry for the PortType
    If (RegOpenKeyExA(HKEY_LOCAL_MACHINE, "Software\Dallas Semiconductor\iButton TMEX\3.00", 0, KEY_READ, GlobKey) = ERROR_SUCCESS) Then
        RtSize = 150
        If (RegQueryValueExA(GlobKey, "DefaultPortType", vbNullString, RtType, cstring(0), RtSize) = ERROR_SUCCESS) Then
        '// check to verify that the return type is string
            If (RtType = REG_SZ) Then
                NBuf = ""
                i = 1
                While (Asc(Mid(cstring, i, 1)) <> 0)
                    NBuf = NBuf + Mid(cstring, i, 1)
                    i = i + 1
                Wend
                PortType = Val(NBuf)
            End If
        End If
    '// release the key
        Dummy = RegCloseKey(GlobKey)
    End If
    
'// get the main and hardware driver version
    i = Get_Version(Buf)
    NBuf = Left$(Buf, InStr(1, Buf, Chr$(0), 1) - 1)
    Timevb32.Label3.Caption = NBuf
    If (TMGetTypeVersion(PortType, Buf) > 0) Then
        NBuf = Left$(Buf, InStr(1, Buf, Chr$(0), 1) - 1)
        Timevb32.Label4.Caption = Timevb32.Label4.Caption + Chr$(&HD) + NBuf
    End If
    
'// Start session
    SHandle = -1
    While (SHandle <= 0)
        SHandle = TMExtendedStartSession(PortNum, PortType, vbNullString)
    Wend

'// Setup must be successful
    If (TMSetup(SHandle) = 1) Then
        Call FindFirstFamily(family, SHandle)
        Timevb32.Show
    Else
        MsgBox ("Error: Failed to setup MicroLan! Trying again.")
        setupdone = TMSetup(SHandle)
        Call FindFirstFamily(family, SHandle)
        Timevb32.Show
    End If
'// Release the 1-wire
    TMEndSession (SHandle)
End Sub
Function ConvertTimeToSeconds() As Long

    Dim i As Integer
    Dim MyTime As Variant
    Dim YR As Long
    Dim MO As Long
    Dim DA As Long
    Dim HR As Long
    Dim MN As Long
    Dim SC As Long
    Dim TotDays As Long
    Dim TotSeconds As Long
    Dim ExtraDay As Long
    Dim LeapYearFlag As Byte
    Dim dm(14) As Long

    dm(0) = 0
    dm(1) = 0
    dm(2) = 31
    dm(3) = 59
    dm(4) = 90
    dm(5) = 120
    dm(6) = 151
    dm(7) = 181
    dm(8) = 212
    dm(9) = 243
    dm(10) = 273
    dm(11) = 304
    dm(12) = 334
    dm(13) = 365
    
'// Read PC's clock
    MyTime = Now
    
'// Break apart MyTime into constituent parts
    YR = year(MyTime)
    MO = month(MyTime)
    DA = day(MyTime)
    HR = hour(MyTime)
    MN = Minute(MyTime)
    SC = Second(MyTime)

'// Error if Year < 1970
    If (YR < 1970) Then
        MsgBox ("Error: Century too small. Try again.")
        Exit Function
    End If
    
'// The following algorithm calculates number of seconds since Jan 1, 1970.

'// first, find if year is a leap year...
    If (((YR Mod 4 = 0) And (YR Mod 100 <> 0)) Or (YR Mod 400 = 0)) Then
        LeapYearFlag = 1    '// it is a leap year.
    Else
        LeapYearFlag = 0    '// it is not a leap year.
    End If
'// If it is leap year and after February, then add a day.
    If ((LeapYearFlag = 1) And (MO > 2)) Then
        ExtraDay = 1
    Else
        ExtraDay = 0
    End If
'// Calculate Total number of days since 1970.
    TotDays = 365 * (YR - 1970) + ((YR - 1969) \ 4) + dm(MO) + DA + ExtraDay - 1
'// Calculate Total number of seconds since 1970.
    TotSeconds = (TotDays * 24 * 3600) + (HR * 3600) + (MN * 60) + SC
    
    ConvertTimeToSeconds = TotSeconds
    
End Function
